      SUBROUTINE NOREXT(QI,Q1,Q2,Q3,NK)
C
C STEPHANE BALAC -- IRMAR -- JUIN 1995
C DERNIERE MODIFICATION :  8 JUIN 1995
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
C RENVOI NK VECTEUR NORMAL AU PLAN {Q1,Q2,Q3}. LA NORMALE EST LA 
C NORMALE EXTERIEUR SI ON ORIENTE L'ESPACE DE SORTE QUE QI SOIT 
C UN POINT INTERIEUR.
C 
C ZERO : VALEUR A PARTIR DE LAQUELLE UNE COMPOSANTE DU VECTEUR NORMAL 
C        EST CONSIDEREE NULLE (POUR UNE NORME 1)
C ISZERO(K) : TABLEAU PERMETTANT DE TESTER SI ON A DEJA MIS LA 
C             COMPOSANTE K DE LA NORMALE A ZERO.
C OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=5.0D-02)
      DOUBLE PRECISION QI(3),Q1(3),Q2(3),Q3(3),NK(3)
      DOUBLE PRECISION NORME,DSQRT,DTEST,DSCAL
      INTEGER IRAF,I,ISZERO(3)

      ISZERO(1)=0
      ISZERO(2)=0
      ISZERO(3)=0
      CALL DPDTVE(Q1,Q2,Q3,NK,2)
10    IRAF=0
      NORME=DSQRT(NK(1)**2 +NK(2)**2 +NK(3)**2 ) 
      DO 20 I=1,3
        NK(I)=NK(I)/NORME           
        IF ((ABS(NK(I)).LT.ZERO).AND.(ISZERO(I).NE.1)) THEN 
          NK(I)=0.D0
          ISZERO(I)=1
          IRAF=1
        ENDIF
20    CONTINUE 
C ON RAFFINE !!
      IF (IRAF.NE.0) GOTO 10

        DTEST=DSCAL(Q1,QI,NK,3,3)
        IF (DTEST.LT.0.D0) THEN
          DO 30 I=1,3
30          NK(I)=-NK(I)
        ENDIF  

      END
