      SUBROUTINE CALB(M,XM,NFNOPO,NINOPO,NOMFIC,UNIT)

C STEPHANE BALAC -- IRMAR -- JUIN 1995
C DERNIERE MODIFICATION : 14 NOVEMBRE 1997
C oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
      DOUBLE PRECISION MU0,PI
      PARAMETER(PI = 3.14159265358979D00, MU0=4*PI*1.D-7)
      DOUBLE PRECISION ZERO
      PARAMETER(ZERO=0.0D0)
C DECLARATION VARIABLES MODULEF       
      INTEGER M(*),NFNOPO,NINOPO
      REAL XM(*)
      CHARACTER*4 CHAR4, NOMFIC*72
      INTEGER NZNOPO(19)
      INTEGER NENOPO,NNOP0,IANOP0,LNOP0,NNOP1,IANOP1,LNOP1,NNOP2,IANOP2
     + ,LNOP2,NNOP3,IANOP3,LNOP3, NNOP4,IANOP4,LNOP4,NNOP5,IANOP5,LNOP5
      INTEGER NE,NDIM,NCOPNP,IA5,NCGE,NDSDE,NNO,NPO,ICNO  
      LOGICAL ITEST,ISORT
      CHARACTER*4 OUINON,NCNO
C DECLARATION VARIABLES LOCALES 
      DOUBLE PRECISION P(3),Q(3,6),PIN(3),B(3),VALTRI(3),AIM(3),NK(3)
      DOUBLE PRECISION A(3),U(3),V(3),LU,LV,PASU,PASV
      DOUBLE PRECISION Z(3)
      DOUBLE PRECISION Bz
      DOUBLE PRECISION DSCAL,CALHK,DIST
      DOUBLE PRECISION DISTMIN,DISTK,VAL1,HK
      DOUBLE PRECISION C0(3),H
      REAL VAR,TVAR(3),VAR2
      INTEGER I,J,IPO,IE,UNIT,CIN,IH
      LOGICAL LTEST
      INTEGER LEVEL   


      COMMON/ALNOPO/NENOPO,NNOP0,IANOP0,LNOP0,NNOP1,IANOP1,LNOP1,
     +                     NNOP2,IANOP2,LNOP2,NNOP3,IANOP3,LNOP3,
     +                     NNOP4,IANOP4,LNOP4,NNOP5,IANOP5,LNOP5
      EQUIVALENCE (NENOPO,NZNOPO(1))

      IMPRIM = IINFO('IMPRIMANTE')
      WRITE(IMPRIM,*)' PARAMETRE D''IMPRESSION (0-10)'
      READ(*,*) IMPRE
C
C     -------------------------------------------------------
C     ---            LECTURE DES DONNEES                  ---
C     -------------------------------------------------------
C
12    WRITE(*,*)' LE REPERE EST CELUI ASSOCI  LA PICE POUR',
     &          ' LE MAILLAGE'
      WRITE(*,*)
      WRITE(*,'(A,$)')' VECTEUR AIMANTATION (3*R): '
      READ(*,*,ERR=12) (TVAR(I),I=1,3)
      DO 110 I=1,3
110   AIM(I) = DBLE(TVAR(I))


C CALCUL DE LA DIRECTION DU CHAMP B0
      CALL DRNORM(AIM,Z,3)

      WRITE(*,'(A,$)')' COORDONNEES D''UN POINT INTERIEUR (3*R -- CM): '
      READ(*,*,ERR=12) (TVAR(I),I=1,3)
      DO 111 I=1,3
111   PIN(I) = DBLE(TVAR(I))*1.D-2

C DEFINITION DU PLAN DE COUPE 
      WRITE(*,*)'####################################'
      WRITE(*,*)' VEUILLEZ DEFINIR LE PLAN DE COUPE'
      WRITE(*,*)'####################################'
      WRITE(*,'(A,$)')' ORIGINE A (3*R -- CM): '
      READ(*,*) (TVAR(I),I=1,3)
      DO 112 I=1,3
112   A(I) = DBLE(TVAR(I))*1.D-2
      WRITE(*,'(A,$)')' 1er VECTEUR DIRECTEUR U (3*R): '
      READ(*,*) (TVAR(I),I=1,3)
      DO 113 I=1,3
113   U(I) = DBLE(TVAR(I))
      CALL DRNORM(U,U,3)
      WRITE(*,'(A,$)')' 2eme  VECTEUR DIRECTEUR V (3*R): '
      READ(*,*)(TVAR(I),I=1,3)
      DO 114 I=1,3
114   V(I) = DBLE(TVAR(I))
      CALL DRNORM(V,V,3)
      WRITE(*,'(A,$)')' DIMENSION DE LA COUPE (LU,LV) (2*R -- CM): '
      READ(*,*) VAR,VAR2
      LU = DBLE(VAR)*1.D-2  
      LV = DBLE(VAR2)*1.D-2

      WRITE(*,'(A,$)')' NOMBRE DE POINTS DE DISCRETISATION : '
      READ(*,*)  NU
      NV=NU
      PASU=LU/(NU-1)
      PASV=LV/(NV-1)  
 
      WRITE(UNIT,*) NU,NV
C     -------------------------------------------------------
C     ---                INITIALISATIONS                  ---
C     -------------------------------------------------------
C
C RESTAURE EN M.C. LA S.D.E. DE NOM 'NOPO' A PARTIR DU FICHIER NFNOPO.
C NCNO (ICNO) = NOM (ADRESSE) DU TABLEAU DE SAUVEGARDE DU COMMON  DE LA S.D
      CALL SDREST(M,'NOPO',NFNOPO,NINOPO,NZNOPO,19,NCNO,ICNO)
C
C POINTEURS SUR LES TABLEAUX NOP2, NOP4 ET NOP5 DE LA SDE NOPO
      IANOP2 = M(ICNO +  8)
      IANOP4 = M(ICNO + 14)
      IANOP5 = M(ICNO + 17)
c LECTURE DES CARACTERISTIQUES DU MAILLAGE
      NDIM   = M(IANOP2)
      IF (NDIM.NE.3) STOP'*** ERREUR CALB: NDIM <> 3 ***'
      NE     = M(IANOP2 +  4)
      NP     = M(IANOP2 + 21)
C NCOPNP = 0 SI DES POINTS SONT NON-NOEUDS; 1 SINON							 	 
      NCOPNP = M(IANOP2 +  3)
      IF (NCOPNP.NE.1) STOP'*** ERREUR CALB: IL Y A DES POINTS 
     &                             NON-NOEUDS ***'
C
C  ADRESSAGES DYNAMIQUE DE TABLEAUX INTERMEDIAIRES
C ... ON MAJORE LE NBRE DE NOEUDS (DONC DE POINTS) D'UN ELT PAR 20 ...
C TABLEAU DES COORDONNEES DES POINTS
      NOE23 = NDIM * 20
      NOMCO = ICHAR4('XCOO')
      IACOO = 0
      CALL READRE(2,CHAR4(NOMCO),IACOO,NOE23,M,NRET)
C TABLEAU DES NUMEROS DES NOEUDS ET POINTS
      NOE2  = 2 * 20
      NOMXX = ICHAR4('AUX ')
      IANOE = 0
      CALL READRE(1,CHAR4(NOMXX),IANOE,NOE2,M,NRET)
      IAPOI = IANOE + 20
C TABLEAU DES NUMEROS DE REFERENCE
      NOMRE = ICHAR4('NREF')
      LREF  = 26
      IAREF = 0
      CALL READRE(1,CHAR4(NOMRE),IAREF,LREF,M,NRET)


      H=ZERO
      IH=0
C     -------------------------------------------------------
C     ---            BOUCLE SUR LES POINTS P              ---
C     -------------------------------------------------------
      TIMES1 = SECNDS(0.0)
      DO 10 IU=0,NU-1
      NTEST=NINT((100.*IU)/NU)
      IF (MOD(NTEST,10).EQ.0) WRITE(*,*) NTEST, '%'
      DO 10 IV=0,NV-1
      
      DO 100 I=1,3
100      P(I)=A(I) + IU*PASU*U(I) +IV*PASV*V(I) 

      DO 101 I=1,3
101      B(I)=0.D0
C
      DISTMIN=1D10
C
C     -------------------------------------------------------
C     ---            BOUCLE SUR LES ELEMENTS              ---
C     -------------------------------------------------------
C
      IA5 = IANOP5
      DO 20 IE=1,NE
C LECTURE DU TABLEAU NOP5 ET ACTUALISATION DE IA AU DEBUT DE L'ELEMENT SUIVANT.
C   NCGE: CODE GEOMETRIQUE DE L'ELEMENT - NDSDE: NUMERO DU DOMAINE AUQUEL 
C   APPRARTIENT L'ELEMENT - NNO,M(IANOE): NB DE NOEUDS ET TABLEAU DES NUM DES
C   NOEUDS DE L'ELT - NPO,M(IAPOI): NB DE POINTS ET TABLEAU DES NUM DES POINTS
C   XM(IACOO): TABLEAU DES COORDONNEES DES NPO POINTS DE L'ELT - M(IAREF):
C   TABLEAU DES REFERENCES SUR L'ELT.
        CALL CLNOPO(M,M,IANOP2,IANOP4,IA5,NCGE,NDSDE,NNO,M(IANOE),
     +               NPO,M(IAPOI),XM(IACOO),M(IAREF))
      IF(NCGE.NE.3) STOP 'MAILLAGE EN TRIANGLES VIA SURFXX' 
C
C ON RECUPERE LES COORDONNEES DES SOMMETS/NOEUDS DU TRIANGLE
C
        IA=IACOO-1
        DO 30 IPO=1,NNO
          DO 31 I=1,NDIM
            IA=IA+1
31          Q(I,IPO) = DBLE(XM(IA))
30      CONTINUE
C
C CALCUL DE L'INTEGRALE SUR LE TRIANGLE
C
        IF (NDSDE.EQ.1) THEN 
C --------------------------
C ------- TRIANGLE P1  -----
C --------------------------
C CALCUL DE LA DISTANCE DE P A K
          DISTK = DIST(P,Q,DISTMIN,C0,LTEST)
C CALCUL ANALYTIQUE DE L'INTEGRALE DE r/r SUR LE  TRIANGLE 
          CALL CALTRI(P,Q,VALTRI)
C TEST LA VALIDITE DU RESULTAT
          CALL ISNAN(VALTRI,IE)
C PRODUIT SACLAIRE PAR L'AIMANTATION
          VAL1=DSCAL(AIM,VALTRI,VALTRI,3,2)
C NORMALE EXTERIEURE A LA SURFACE
          CALL NOREXT(PIN,Q(1,1),Q(1,2),Q(1,3),NK)
C CALCUL DE LA CONTRIBUTION DE L'ELT AU CHAMP MAGNETIQUE
          DO 50 J=1,3
50         VALTRI(J) = VAL1*NK(J)
C
        ELSE
        IF (NDSDE.EQ.2) THEN 
C --------------------------
C ------- TRIANGLE P2  -----
C --------------------------
C CALCUL DE LA TAILLE DU TRIANGLE K
          HK = CALHK(Q)
          H  = H + HK
          IH = IH+1
C CALCUL DE LA DISTANCE DE P A K
          DISTK = DIST(P,Q,DISTMIN,C0,LTEST)
C    
C METHODE DE QUADRATURE D'ATKINSON ORDRE 2
C LE CHOIX DE LA FORMULE D'INTEGRATION DEPEND DE LA DISTANCE DE P A K
          CALL  SETLEV(DISTK,HK,NFORM,LEVEL)  
          IF (NFORM.EQ.3) THEN     
            CALL FQE3P(VALTRI,Q,P,AIM,PIN)
          ELSEIF (NFORM.EQ.2) THEN
            CALL SMPLX2(VALTRI,LEVEL,Q,P,AIM,PIN)
          ELSEIF (NFORM.EQ.1) THEN
            CALL CALTRI(P,Q,VALTRI)
            CALL ISNAN(VALTRI,IE)
            VAL1=DSCAL(AIM,VALTRI,VALTRI,3,2)
            CALL NOREXT(PIN,Q(1,1),Q(1,2),Q(1,3),NK)
            DO 501 J=1,3
501           VALTRI(J) = VAL1*NK(J)
          ENDIF         
C
        ELSE
        STOP'*** CALB: NDSDE <> 1 OU 2 ***'
        ENDIF
        ENDIF
C
C ON SOMME CETTE VALEUR
      DO 60 J=1,3
60      B(J) =  B(J) + VALTRI(J)

C ELEMENT SUIVANT
20    CONTINUE 
C
C     -------------------------------------------------------
C     ---          CALCUL DU CHAMP MAGNETIQUE             ---
C     -------------------------------------------------------
C
C LE POINT EST IL INTERIEUR ?
         CIN=1 
         IF (DSCAL(C0,P,PIN,3,1).LT.0) CIN=0 
C NORMALISATION PAR MU0/4*PI + TERME SUPPLEMENTAIRE POUR L'INTEGRALE INTERIEURE
        DO 70 J=1,3
70        B(J) =  B(J)*1.D-7 + CIN*MU0*AIM(J)
        Bz = DSCAL(B,Z,Z,3,2)
C ON STOCKE LA COMPOSANTE DU CHAMP INDUIT SUIVANT LA DIRECTION Z DU CHAMP
C INDUCTEUR BO        
90      WRITE(UNIT,*)  IU+1,IV+1,REAL(Bz),CIN
10    CONTINUE

      WRITE(*,*) '******************************************'
      WRITE(*,*) char(7),char(7)
      WRITE(*,*) '* Dure du module : ', nint(secnds(TIMES1)),'s.'
      WRITE(*,*) '******************************************'


      WRITE(*,*) 'LE PAS H CALCUL POUR LA SURFACE P2 VAUT H=',H/IH
      END




















