      SUBROUTINE CALTRI(P,Q,VALTRI)

C 
C Q(*,I) : IEME SOMMET DU TRIANGLE
C VAL(*,I) : VALEURS DE L'INTEGRALE VECTORIELLE POUR LE TRIANGLE ELEMENTAIRE KI
C TBS(S,L3,L2,L1) : TABLEAU GERANT LES SIGNES DES INTEGRALES ELEMENTAIRES  
C                   SUIVANT LAPOSITION DE Q0 PAR RAPPORT AU TRIANGLE.
C LI(Q0) < 0 => LI = 0 ;  LI(Q0) > 0 => LI = 1.
C S VARIE DE 1 A 3 ET DONNE LES SIGNES: S = (S1,S2,S3), SI=0 => "-" INTEGRALE I;
C                                                       SI=1 => "+" INTEGRALE I.
      DOUBLE PRECISION P(3),Q0(3),Q(3,6)
      DOUBLE PRECISION H,L(3),VAL(3,3),FAC(3),VALTRI(3),DSIG
      INTEGER I,J,IP(3),TBS(3,0:1,0:1,0:1),SG(3)
      INTEGER ISIGD
      DATA IP/2,3,1/
      DATA TBS/0,0,0, 1,0,0, 0,0,1, 1,0,1, 0,1,0, 1,1,0, 0,1,1, 1,1,1/

C CALCUL DE Q0 PROJETE ORTHOGONAL DE P SUR LE PLAN {Q1,Q2,Q3} ET H LA DISTANCE.
      CALL PROJEC(P,Q(1,1),Q(1,2),Q(1,3),Q0,H)
C CALCUL DES COORDONNEES BARYCENTRIQUES DE Q0 RELATIVEMENT A {Q1,Q2,Q3}.
      CALL CBARY(Q0,Q(1,1),Q(1,2),Q(1,3),L,3) 
      DO 10 I=1,3
10     SG(I) = ISIGD(L(I))
      DO 11 I=1,3
11     FAC(I) = DSIG(TBS(I,SG(3),SG(2),SG(1)))
      DO 20 I=1,3 
        CALL INTELM(P,Q0,Q(1,I),Q(1,IP(I)),H,VAL(1,I))
20    CONTINUE
      DO 30 J=1,3  
        VALTRI(J) = - (FAC(1)*VAL(J,1) + FAC(2)*VAL(J,2) 
     &               + FAC(3)*VAL(J,3)) 
30    CONTINUE

      END
