      DOUBLE PRECISION FUNCTION CALHK(Q)
C
C STEPHANE BALAC -- IRMAR -- OCTOBRE 1997
C 
C RENVOI LA MOYENNE DES LONGUEURS DES COTES DU TRIANGLE DONT LES SOMMETS
C SONT LES POINTS Q

      DOUBLE PRECISION Q(3,6),SOM

      SOM=0.D0
      DO 10 I=1,3
        J=I+1
        IF (J.EQ.4) J=1
        SOM=SOM + DSQRT((Q(1,I)-Q(1,J))**2+(Q(2,I)-Q(2,J))**2
     &                +(Q(3,I)-Q(3,J))**2)

10    CONTINUE

      CALHK=SOM/3.D0
      END

C oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
      DOUBLE PRECISION FUNCTION DIST(P,Q,DMIN,C0,LTEST)
C
C STEPHANE BALAC -- IRMAR -- NOVEMBRE 1997
C 
C RENVOI LA DISTANCE DU POINT P AU CENTRE DU TRIANGLE DONT LES SOMMETS SONT
C LES POINTS DU TABLEAU Q
C SI LA DISTANCE EST < A DMIN ALORS DMIN = DIST ET C0 CONTIENT LES COORDONNEES
C DU CENTRE DU TRIANGLE. ON A ALORS LTEST = TRUE.
C 

      DOUBLE PRECISION TROIS
      PARAMETER (TROIS=3.0D0)
      DOUBLE PRECISION Q(3,6),P(3),C0(3),CK(3),DMIN
      LOGICAL LTEST

      LTEST = .FALSE.
      DO 10 I=1,3
10      CK(I) = (Q(I,1)+Q(I,2)+Q(I,3))/TROIS

      DIST=DSQRT((P(1)-CK(1))**2+(P(2)-CK(2))**2
     &          +(P(3)-CK(3))**2)

      IF (DIST.GT.DMIN) RETURN

      LTEST = .TRUE.
      DMIN = DIST
      DO 20 I=1,3
20      C0(I)=CK(I)
          
      END
C oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
        
