
      SUBROUTINE SETLEV(DISTK,HK,NFORM,LEVEL)
C
C     RENVOI LE TYPE DE FORMULE D'INTEGRATION A UTILISER EN FONCTION DE 
C     LA DISTANCE DISTK DE P A K.
C
C     ENTREE: 
C      DISTK = DISTANCE DE P A K.
C      HK    = DIMENSION DU TRIANGLE
C     SORTIE:
C      NFORM = TYPE DE FORMULE  3 = FORMULE NUMERIQUE A 3 NOEUDS
C                               2 = FORMULE NUMERIQUE A 7 NOEUDS
C                               1 = FORMULE EXACTE POUR UN TRIANGLE PLAT  
C      LEVEL = NOMBRE DE SUBDIVISIONS DU DOMAINE D'INTEGRATION SI NFORM=2
C
      DOUBLE PRECISION CINQ,DEUX,UNETDEM,UN,UNDEMI
      PARAMETER(CINQ=5.0D0,DEUX=2.0D0,UNETDEM=1.5D0,UN=1.0D0,
     &          UNDEMI=0.5D0)
      DOUBLE PRECISION DISTK,HK,DELTA
      INTEGER NFORM,LEVEL

      LEVEL = 100
      DELTA = DISTK/HK

      IF (DELTA.GT.CINQ) THEN
        NFORM=3 
        RETURN
      ELSEIF (DELTA.GT.DEUX)  THEN
        NFORM = 2
        LEVEL = 0
        RETURN 
      ELSEIF (DELTA.GT.UNETDEM)  THEN
        NFORM = 2
        LEVEL = 1
        RETURN 
      ELSEIF (DELTA.GT.UN)  THEN
        NFORM = 2
        LEVEL = 2
        RETURN 
      ELSEIF (DELTA.GT.UNDEMI)  THEN
        NFORM = 2
        LEVEL = 3
        RETURN 
      ELSE
        NFORM=1
      ENDIF

      END
